/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#include "stdafx.h"
#include "FileAccess.h"
#include "define.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

/***********************************************************************************************/
/* Title	 : \zCvg֐                                                          */
/* Function	 : CXipsFileAccess::CXipsFileAccess(												*/
/*					char *pszDbName,															*/
/*					int nRcSize,																*/
/*					BOOL *pbResult)																*/
/* Parameters: char *pszDbName	(i/ ):DB                                                   */
/*             int	nRcSize		(i/ ):R[hTCYi1R[hj                            */  
/*             BOOL *pbResult    ( /o):                                                    */
/* Return       : Ȃ                                                                         */ 
/*                                                                                             */
/* Description	: IuWFNg\zA R[h̃TCYf[^ݒ肷B                      */
/***********************************************************************************************/
CXipsFileAccess::CXipsFileAccess(const CString& strFileName, int nRcSize, BOOL *pbResult,int nOpenFlag)
{
	ASSERT(!strFileName.IsEmpty());

	*pbResult=TRUE;							//I

	// t@CR[hTCYێ
	m_nRcSize = nRcSize;

	// t@CIuWFNg쐬
	TRY{  
		m_poDb = NULL;					//擾|C^[
		if (nOpenFlag == FILE_WRITE){
			m_poDb = new CFile(strFileName, //CFile::modeNoTruncate |
											CFile::modeCreate | 
											CFile::modeWrite  |
											CFile::shareExclusive  
											);
		}
		else{
			m_poDb = new CFile(strFileName, CFile::modeRead  |
											CFile::shareDenyNone
											);
		}
	}

	//I[vs̗OLb`				
	CATCH( CFileException, poEx ){ 
	    *pbResult = FALSE;
		TCHAR szCause[256];
		memset(szCause, 0, sizeof(szCause));
		poEx->GetErrorMessage(szCause, sizeof(szCause));
		TRACE(szCause);
	}
	END_CATCH
}

/********************************************************************/
/* Title	 : fXgN^[Cvg֐                     */
/* Function	 : CXipsFileAccess::~CXipsFileAccess()                  */
/* Parameters:                                                      */
/* Return       :                                                   */
/*                                                                  */
/* Description	:                                                   */
/********************************************************************/
CXipsFileAccess::~CXipsFileAccess()
{
	// t@CIuWFNg|C^[΁A̎
	if( m_poDb!=NULL ){
		m_poDb->Close();
		delete m_poDb;
	}
}
/**************************************************************************************/
/*                                                                                    */
/* Title	 : R[hf[^Write                                                */
/* Function	 : CXipsFileAccess::uRecWrite( int nRecNo, int nRecCnt,   char *psBuff )  */
/* Parameters: int      nRecNo       (i/ ):R[hNo                                 */ 
/*             int      nRecCnt      (i/ ):R[h                                 */ 
/*             char*    psBuff       (i/ ):R[hɏރf[^                     */              
/* Return    : TRUE                       :                                       */  
/*             FALSE                      :ُ                                       */
/*                                                                                    */  
/* Description: t@C̎w肵R[hɃf[^                            */
/*                                                                                    */
/*                                                                                    */
/**************************************************************************************/
BOOL CXipsFileAccess::uRecWrite(int nRecNo, int nRecCnt, char* psBuff)
{
	int	nTopWrite=0;						//݈ʒu

	// ݈ʒuZoiw背R[hNo~R[hTCYj
	nTopWrite = ( (nRecNo-1) * (m_nRcSize+2)) + (m_dwVision+2);

	//݈ʒuݒ
	TRY{
		m_poDb->Seek( nTopWrite, CFile::begin );
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	//
	TRY{  
		m_poDb->Write( psBuff, (m_nRcSize * nRecCnt)  );
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	//enter
	TRY{  
		char szCmdEndStr[3]={0x0d,0x0a,0x00};//0x0a,
		m_poDb->Write(szCmdEndStr,2);
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH


	return TRUE;
}

BOOL CXipsFileAccess::uRecVisionWrite(int nVisionLength, char *pBuff)
{
	//݈ʒuݒ
	TRY{  
		m_poDb->Seek( 0, CFile::begin );
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	//
	TRY{  
		m_poDb->Write( pBuff, nVisionLength);
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH
   
    //enter
	TRY{  
		char szCmdEndStr[3]={0x0d,0x0a,0x00};//0x0a,
		m_poDb->Write(szCmdEndStr,2);
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	m_dwVision = nVisionLength;

	return TRUE;
}

BOOL CXipsFileAccess::uGetOffset(DWORD &dwOffset)
{
	TRY{
		dwOffset=m_poDb->GetPosition();

	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	return TRUE;
}

BOOL CXipsFileAccess::uRecRead(int nRecOffset, int nRecCnt, char *psBuff)
{
	if(nRecOffset<0)
		return FALSE;

	// TCY`FbN
	int nSize = m_poDb->GetLength();
	if( nSize<=0 ){
		return FALSE;
	}

	//ǂݍ݈ʒuݒ
	TRY{  
		m_poDb->Seek( nRecOffset, CFile::begin );		
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	//ǂݍ	
	TRY{  
		m_poDb->Read( psBuff,  (m_nRcSize * nRecCnt) );
	}
	CATCH( CFileException, poEx ){ 
	    return FALSE;
	}
	END_CATCH

	return TRUE;
}

BOOL CXipsFileAccess::uGetRecordCount(DWORD &dwCount)
{
	DWORD dwSize = m_poDb->GetLength();
	if( dwSize<=0 ){
		return FALSE;
	}

	dwCount=(dwSize-(FILEVERSION+1)-2)/(m_nRcSize + 2);

	return TRUE;
}

BOOL CXipsFileAccess::uRecSeek(long offset, int origin)
{
	TRY {
		m_poDb->Seek(offset,origin);
	} CATCH (CFileException,poEx) {
		return FALSE;
	}
	END_CATCH
	return TRUE;
}

