/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#include "stdafx.h"
#include "Log.h"

typedef struct _FileList {
    int nel;
    int size;
    WIN32_FIND_DATA *fd;
    TCHAR dirname[MAX_PATH];
} FileList;

#define NUM_ALLOC  128


BOOL logPurge(LPTSTR lpszFilePath, const int nDays);
static FileList* GetFileList(LPTSTR dirname);
static FileList* AllocFileList(int size);
static void FreeFileList(FileList *fl);
static void CopyFileList(FileList *dst, FileList *src);
static void SetFileList(FileList *fl, WIN32_FIND_DATA *fd);
int FNameCompare(const void *arg1, const void *arg2);
int TimeCompare(const void *arg1, const void *arg2);
static int IsDigitStr(LPCTSTR str);


BOOL
logPurge(LPTSTR lpszFilePath, const int nDays)
{
    int i;
    FileList *fl;
    TCHAR path[MAX_PATH];

    _ASSERT(lpszFilePath != NULL);
	_ASSERT(nDays > 0);

	if ((fl = GetFileList(lpszFilePath)) == NULL) {
		return FALSE;
	}
    for(i=0; i<fl->nel - nDays; i++) {
		_stprintf(path, _T("%s\\%s"), fl->dirname, fl->fd[i].cFileName);
		if (_tunlink(path) != 0) {
			return FALSE;
		}
	}

    return TRUE;
}

static FileList *
GetFileList(LPTSTR dirname)
{
    int len;
    FileList *fl, *work;
    HANDLE h;
    WIN32_FIND_DATA fd;
    TCHAR path[MAX_PATH];

    len = _tcslen(dirname);
    if (dirname[len-1] == '\\') {
		_stprintf(path, _T("%s*.*"), dirname);
		dirname[len-1] = '\0';
    } else {
		LPTSTR p;
		_tcscpy(path, dirname);
		if ((p = _tcsrchr(dirname, '\\')) != NULL) {
		    *p = '\0';
		}
    }

    fl = AllocFileList(NUM_ALLOC);
    _tcscpy(fl->dirname, dirname);
    if ((h = FindFirstFile(path, &fd)) == INVALID_HANDLE_VALUE) {
#ifdef DEBUG
		cout << "FindFirstFile() error (" << GetLastError() << ")" << endl;
		return NULL;
#endif
		_ASSERT(FALSE);
    }
    SetFileList(fl, &fd);
    while(FindNextFile(h, &fd)) {
		SetFileList(fl, &fd);
		if (fl->nel >= fl->size) {
		    work = AllocFileList(fl->size+NUM_ALLOC);
		    CopyFileList(work, fl);
		    FreeFileList(fl);
		    fl = work;
		}
    }
    FindClose(h);

	//
	// FNameCompare̓t@CŃ\[gB
	// TimeCompare̓t@C̓tŃ\[gB
	// 
	qsort(fl->fd, fl->nel, sizeof(WIN32_FIND_DATA), FNameCompare);
//    qsort(fl->fd, fl->nel, sizeof(WIN32_FIND_DATA), TimeCompare);

    return fl;
}

static void
SetFileList(FileList *fl, WIN32_FIND_DATA *fdp)
{
    if (fdp->dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY) {
		memcpy(&fl->fd[fl->nel], fdp, sizeof(WIN32_FIND_DATA));
		fl->nel++;
    }
}

static FileList *
AllocFileList(int size)
{
    FileList *fl;

    if ((fl = (FileList *)calloc(1, sizeof(FileList))) == NULL) {
		_ASSERT(FALSE);		/* insufficient memory */
    }
    if ((fl->fd = (WIN32_FIND_DATA *)calloc(size, sizeof(WIN32_FIND_DATA))) == NULL) {
		_ASSERT(FALSE);		/* insufficient memory */
    }
    fl->size = size;
    return fl;
}

static void
FreeFileList(FileList *fl)
{
    free(fl->fd);
    free(fl);
}

static void
CopyFileList(FileList *dst, FileList *src)
{
    memcpy(dst->fd, src->fd, sizeof(WIN32_FIND_DATA)*src->nel);
    _tcscpy(dst->dirname, src->dirname);
    dst->nel = src->nel;
}

//
// t@CŔr
//
int
FNameCompare(const void *arg1, const void *arg2)
{
    return _tcscmp(((WIN32_FIND_DATA *)arg1)->cFileName,
					((WIN32_FIND_DATA *)arg2)->cFileName);
}

//
// t@C̓tŔr
//
int
TimeCompare(const void *arg1, const void *arg2)
{
    return CompareFileTime(&(((WIN32_FIND_DATA *)arg1)->ftLastWriteTime),
						&(((WIN32_FIND_DATA *)arg2)->ftLastWriteTime));
}

static int
IsDigitStr(LPCTSTR str)
{
    for( ; *str; str++) {
		if (!_istdigit(*str)) {
		    return FALSE;
		}
    }
    return TRUE;
}
