/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

#include "stdafx.h"
#include "Log.h"
//#include "XcLog.h"


static void DbgDsp(const char *msg, const int no);
extern BOOL logPurge(LPTSTR filePath, const int nDays);


//
// 
//
XCLOGH WINAPI
XcLogInit(LPCTSTR logRootDir, LPCTSTR filePrefix, int nDays)
{
	if(logRootDir == NULL || filePrefix == NULL || nDays <= 0) {
		DbgDsp("Illegal parameter.", 0);
		return NULL;
	}

	TCHAR filepath[MAX_PATH+1];
	int cleanFlg = 0;


	//
	// Ot@Ci[fBNg邩ǂׂ
	// Ȃ΁AG[^[
	//
	if(_access((LPCSTR)logRootDir, 0) < 0) {
		DbgDsp("Path not found.", 0);
		return NULL;
	}

	//
	// {̃Ot@C邩ǂׂ
	// Ȃ΁AɁAۑԂ߂Ot@C폜
	// Ot@CFlogRootDir\filePrefix-YYYYMMDD.log
	//
	time_t t;
	struct tm *today;
	time(&t);
	today = localtime(&t);
	sprintf((LPSTR)filepath, "%s\\%s",//-%d%02d%02d.log", 
			logRootDir, filePrefix/*,
			today->tm_year+1900, today->tm_mon+1, today->tm_mday*/);
	if(_access((LPSTR)filepath, 0) < 0) {
		cleanFlg = 1;
	}
	

	//
	// Ot@CI[vB
	// Ȃ΁Ãt@C쐬B̏ꍇAĂяõvZX
	// XcLogWrite()1R[ɏIꍇ́Ãt@CcB
	// READ-WRITELFMOɃO\c[N鋰ꂪ邽߁B
	//
	HANDLE hndl = CreateFile(filepath,
						GENERIC_WRITE,
						FILE_SHARE_READ|FILE_SHARE_WRITE,
						NULL,
						OPEN_ALWAYS,
						FILE_ATTRIBUTE_NORMAL,
						NULL);
	if(hndl == INVALID_HANDLE_VALUE) {
		DbgDsp("CreateFile() error.", GetLastError());
		return NULL;
	}
	CloseHandle(hndl);


	XCLOGH lpLogHandle = new XCLOG;
	strncpy((LPSTR)lpLogHandle->logFilePath, (LPSTR)filepath, MAX_PATH+1);


	//
	// {̃Ot@C̊֐R[Oɂꍇ́A
	// ɃfBNg̑|(ÂO̍폜)sĂ̂ŁA
	// ł͑|sȂ
	//
	if(cleanFlg == 0) {
		return lpLogHandle;
	}

	//
	// fBNg̑|(ÂO̍폜)
	// (St@C - nDays)̌Ât@C폜B
	// 폜Ώۃt@CFlogRootDir/filePrefix-*.log
	//
//	sprintf((LPSTR)filepath, "%s\\%s-*.log", logRootDir, filePrefix);
//	if(!logPurge((LPTSTR)filepath, nDays)) {
//		XcLogFree(lpLogHandle);
//		DbgDsp("logPurge() error.", 0);
//		return NULL;
//	}

	return lpLogHandle;
}

//
// 
//
BOOL WINAPI
XcLogWrite(XCLOGH hLOG, const char *msgID, const char *message)
{
	if(hLOG == NULL || msgID == NULL || message == NULL) {
		DbgDsp("Illegal parameter.", 0);
		return NULL;
	}

	LPOVERLAPPED lpOver;
	DWORD dwLockSizeLow = 0xffff;
	DWORD dwLockSizeHigh = 0;
	
	//
	// ޕ񐶐
	// YYYY-MM-DD HH:MM:SS.UUU PID msgID msg
	//
	struct _timeb timebuffer;
	struct tm *today;
	char path[MAX_PATH];
	_ftime(&timebuffer);
	today = localtime(&(timebuffer.time));
	//sprintf(path, "%d-%02d-%02d %02d:%02d:%02d.%03hu %4d %s %s\x0d\x0a",
	sprintf(path, "%d-%02d-%02d %02d:%02d:%02d %s %s\x0d\x0a",
			today->tm_year+1900, today->tm_mon+1, today->tm_mday,
			today->tm_hour, today->tm_min, today->tm_sec,// timebuffer.millitm,
			//_getpid(), 
			msgID, message);


	//
	// READ-WRITELFMOɃO\c[N鋰ꂪ邽߁B
	//
	HANDLE hndl = CreateFile(hLOG->logFilePath,
						GENERIC_WRITE,			// ݃ANZX
						FILE_SHARE_READ|FILE_SHARE_WRITE,	// READ-WRITEL
						NULL,
						OPEN_EXISTING,			// t@C݂Ȃꍇs
						FILE_ATTRIBUTE_NORMAL,
						NULL);
	if(hndl == INVALID_HANDLE_VALUE) {
		DbgDsp("CreateFile() error.", GetLastError());
		return FALSE;
	}

	//
	// File Lock
	//
	lpOver = (LPOVERLAPPED)LocalAlloc(LMEM_ZEROINIT, sizeof(*lpOver));
	if(lpOver == NULL) {
		DbgDsp("LocalAlloc() error.", GetLastError());
		return FALSE;
	}
	lpOver->Offset = lpOver->OffsetHigh = 0;
	lpOver->hEvent = 0;
	if(!LockFileEx(hndl, LOCKFILE_EXCLUSIVE_LOCK, 0, dwLockSizeLow, dwLockSizeHigh, lpOver)) {
		CloseHandle(hndl);
		LocalFree(lpOver);
		DbgDsp("LockFileEx() error.", GetLastError());
		return FALSE;
	}

	//
	// t@C̍Ōɏ
	//
	DWORD szWritten = 0;
	if(SetFilePointer(hndl, 0, NULL, FILE_END) == 0xFFFFFFFF) {
		CloseHandle(hndl);
		LocalFree(lpOver);
		DbgDsp("SetFilePointer() error.", GetLastError());
		return FALSE;
	}
	if(!WriteFile(hndl, (LPCVOID)path, strlen(path), &szWritten, NULL)) {
		CloseHandle(hndl);
		LocalFree(lpOver);
		DbgDsp("WriteFile() error.", GetLastError());
		return FALSE;
	}


	//
	//
	if(!UnlockFileEx(hndl, 0, dwLockSizeLow, dwLockSizeHigh, lpOver)) {
		CloseHandle(hndl);
		LocalFree(lpOver);
		DbgDsp("UnlockFileEx() error.", GetLastError());
		return FALSE;
	}
	LocalFree(lpOver);

	CloseHandle(hndl);

	return TRUE;
}

//
// J
//
void WINAPI
XcLogFree(XCLOGH hLOG)
{
	if(hLOG != NULL) {
		delete hLOG;
	}
}


static void
DbgDsp(const char *msg, const int no)
{
#ifdef _DEBUG
	cout << msg << " (" << no << ")" << endl;
#endif
}
