/****************************************************************************
*                                                                           *
* Copyright (C) 2001-2002 wwa@Ï񕔁A			*
*						  xm[bNX񊔎  BSƕ				*
*                                                                           *
****************************************************************************/

// BasicDBAccess.cpp : CFXISDiseaseBasicDBAccessApp ̃Cve[V DLL ̓o^

#include "stdafx.h"
#include "FXISDiseaseBasicDBAccess.h"
#include "BasicDBAccess.h"

#include "ResultNodeList.h"
#include "ResultConnectiveModifierCategory.h" 
#include "ResultModifierJumpItem.h"
#include "DiseaseDetail.h"
#include "ModifierDetail.h"
#include "KeywordDetail.h"
#include "ResultDiseaseNode.h"
#include "ResultDisease.h"
#include "ResultModifier.h"
#include "ResultModifierNode.h"
#include "ResultKeyword.h"

#include "MedicalSearch.h"
#define RETOK 0
#define RETERR 1
/////////////////////////////////////////////////////////////////////////////
//
MedicalSearch gMedicalSearch;

STDMETHODIMP BasicDBAccess::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IBasicDBAccess,
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP BasicDBAccess::
Initialize(BSTR szDiseaseIndex, BSTR szModifierIndex, 
		   BSTR szKeywordIndex, BSTR szDiseaseTreeIndex, 
		   BSTR szModifierTreeIndex, BSTR szDiseaseDetail, 
		   BSTR szModifierDetail, BSTR szKeywordDetail, 
		   BSTR szModifierClassification, BSTR szDiseaseResemble)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	//NX̃\bh Initialize ĂяoB
	int nRet=gMedicalSearch.Initialize(szDiseaseIndex,szModifierIndex,
						szKeywordIndex,szDiseaseTreeIndex,
						szModifierTreeIndex,szDiseaseDetail,
						szModifierDetail,szKeywordDetail,
						szModifierClassification,szDiseaseResemble);
	if(nRet != RETOK)
		return S_FALSE;
	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetDiseaseNode(int nRetrieveSegerRange, BSTR strDiseasePath,VARIANT* retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetDiseaseNode ĂяoB
	CTypedPtrList <CPtrList, StructResultDiseaseNode * > oResultDiseaseNodeList;
	int nRet=gMedicalSearch.GetDiseaseNode(nRetrieveSegerRange,
		strDiseasePath,&oResultDiseaseNodeList);
	if(nRet != RETOK){
		return S_OK;
	}
	int nCount = oResultDiseaseNodeList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultDiseaseNodeList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultDiseaseNode *pTemp = oResultDiseaseNodeList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultDiseaseNode>* pResultDiseaseNode;
		HRESULT hRes = CComObject<CResultDiseaseNode>::CreateInstance(&pResultDiseaseNode);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultDiseaseNode->m_bLost = pTemp->bLost;
		pResultDiseaseNode->m_strID = CString(pTemp->strID);
		pResultDiseaseNode->m_strKName = CString(pTemp->strKName);
		pResultDiseaseNode->m_strName = CString(pTemp->strName);
		pResultDiseaseNode->m_strPath = CString(pTemp->strPath);
		pResultDiseaseNode->m_strSelectKbn = CString(pTemp->strSelectKbn);
		
		free((void*)pTemp->strPath);
		pTemp->strPath = NULL;
		delete pTemp;
		pTemp = NULL;

		LPDISPATCH lpDisp = NULL;
		pResultDiseaseNode->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	}

	oResultDiseaseNodeList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchDiseaseKeyword(int nRetrieveSegerRange,
 							BSTR szDiseasePath, BSTR szKeyword,
 							BSTR szSynonymKbn,int nRetrieveType,
 							int nMostRetrieveNum,VARIANT_BOOL *bOutReward,
 							VARIANT_BOOL *bOutNumOver,VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchDiseaseKeyword ĂяoB
	CTypedPtrArray <CPtrArray, StructResultDisease * > oResultDiseaseList;
	int nRet=gMedicalSearch.SearchDiseaseKeyword(nRetrieveSegerRange,
						szDiseasePath,szKeyword,szSynonymKbn,nRetrieveType,
						nMostRetrieveNum,&oResultDiseaseList,
						(BOOL*)bOutReward,(BOOL*)bOutNumOver);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultDiseaseList.GetSize();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

//	POSITION pos = oResultDiseaseList.GetHeadPosition();
//	int i = 0;
	for(int i=0;i<nCount;i++)
	{
		StructResultDisease *pTemp = oResultDiseaseList.GetAt(i);
		ASSERT(pTemp);

     	//CX^X
		CComObject<CResultDisease>* pResultDisease;
		HRESULT hRes = CComObject<CResultDisease>::CreateInstance(&pResultDisease);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultDisease->m_strID = pTemp->strID;
		pResultDisease->m_strKeyword = pTemp->strKeyword;
		pResultDisease->m_strKName = pTemp->strKName;
		pResultDisease->m_strName = pTemp->strName;
		pResultDisease->m_strPath = pTemp->strPath;
		pResultDisease->m_strSelectKbn = pTemp->strSelectKbn;
		pResultDisease->m_strSynonymKbn = pTemp->strSynonymKbn;
		free((void*)pTemp->strPath);
		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultDisease->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
	 }

	oResultDiseaseList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
SearchResembleDisease(int nRetrieveSegerRange, BSTR szDiseaseID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchResembleDisease ĂяoB
	CTypedPtrList <CPtrList, StructResultDisease * > oResultDiseaseList;
    int nRet=gMedicalSearch.SearchResembleDisease(nRetrieveSegerRange,
								szDiseaseID,&oResultDiseaseList);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultDiseaseList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultDiseaseList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultDisease *pTemp = oResultDiseaseList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultDisease>* pResultDisease;
		HRESULT hRes = CComObject<CResultDisease>::CreateInstance(&pResultDisease);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultDisease->m_strID = pTemp->strID;
		pResultDisease->m_strKeyword = pTemp->strKeyword;
		pResultDisease->m_strKName = pTemp->strKName;
		pResultDisease->m_strName = pTemp->strName;
		pResultDisease->m_strPath = pTemp->strPath;
		pResultDisease->m_strSelectKbn = pTemp->strSelectKbn;
		pResultDisease->m_strSynonymKbn = pTemp->strSynonymKbn;
		free((void*)pTemp->strPath);
		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultDisease->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	 }

	oResultDiseaseList.RemoveAll();
	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
SearchConnectiveModifier(BSTR strDiseaseID, BSTR strModifierKbn, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchConnectiveModifier ĂяoB
	CTypedPtrList <CPtrList, StructResultModifier * > oResultModifierList;
    int nRet=gMedicalSearch.SearchConnectiveModifier(strDiseaseID,
							strModifierKbn,&oResultModifierList);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultModifierList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;	 
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultModifierList.GetHeadPosition();
	int i = 0;
	while (pos)
	{
		StructResultModifier *pTemp  = oResultModifierList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultModifier>* pResultModifier;
		HRESULT hRes = CComObject<CResultModifier>::CreateInstance(&pResultModifier);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultModifier->m_strID = pTemp->strID;
		pResultModifier->m_strKeyword = pTemp->strKeyword;
		pResultModifier->m_strKName = pTemp->strKName;
		pResultModifier->m_strName = pTemp->strName;
		pResultModifier->m_strSynonymKbn = pTemp->strSynonymKbn;

		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultModifier->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	 }

	oResultModifierList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetConnectiveModifierCategory(BSTR strDiseaseID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetConnectiveModifierCategory ĂяoB
	CArray <StructResultConnectiveModifierCategory*,StructResultConnectiveModifierCategory*> oResultConnectiveModifierCategoryList;
    int nRet=gMedicalSearch.GetConnectiveModifierCategory(strDiseaseID,
									oResultConnectiveModifierCategoryList);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultConnectiveModifierCategoryList.GetSize();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	for(int i = 0; i < nCount; i++)
	{
		StructResultConnectiveModifierCategory *pTemp=oResultConnectiveModifierCategoryList.GetAt(i);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultConnectiveModifierCategory>* pResultConnectiveModifierCategory;
		HRESULT hRes = CComObject<CResultConnectiveModifierCategory>::CreateInstance(&pResultConnectiveModifierCategory);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultConnectiveModifierCategory->m_strKbn = pTemp->strKbn;
		pResultConnectiveModifierCategory->m_strName = pTemp->strName;

		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultConnectiveModifierCategory->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
	 }

	oResultConnectiveModifierCategoryList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchPartModifier(BSTR strModifierKbn, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchPartModifier ĂяoB
	CTypedPtrList <CPtrList, StructResultModifier * > oResultModifierList;
    int nRet=gMedicalSearch.SearchPartModifier(strModifierKbn,&oResultModifierList);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultModifierList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultModifierList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultModifier *pTemp = oResultModifierList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultModifier>* pResultModifier;
		HRESULT hRes = CComObject<CResultModifier>::CreateInstance(&pResultModifier);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultModifier->m_strID = pTemp->strID;
		pResultModifier->m_strKeyword = pTemp->strKeyword;
		pResultModifier->m_strKName = pTemp->strKName;
		pResultModifier->m_strName = pTemp->strName;
		pResultModifier->m_strSynonymKbn = pTemp->strSynonymKbn;
		delete pTemp;
		LPDISPATCH lpDisp = NULL;
		pResultModifier->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	 }
	oResultModifierList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
SearchModifierKeyword(BSTR strKeyWord,
					  BSTR strSynonymKbn,
					  int nRetrieveType, 
					  int nMaxRetrieveNum, 
					  VARIANT_BOOL *bOutReward, 
					  VARIANT_BOOL *bOutCntOver,
					  VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchModifierKeyword ĂяoB
	CTypedPtrArray <CPtrArray, StructResultModifier * > oResultModifierList;
	int nRet=gMedicalSearch.SearchModifierKeyword(strKeyWord,
							strSynonymKbn,nRetrieveType,
							nMaxRetrieveNum,&oResultModifierList,
							(BOOL*)bOutReward,(BOOL*)bOutCntOver);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultModifierList.GetSize();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	for(int i = 0;i<nCount;i++)
	{
		StructResultModifier *pTemp = oResultModifierList.GetAt(i);
		ASSERT(pTemp);

     	//CX^X
		CComObject<CResultModifier>* pResultModifier;
		HRESULT hRes = CComObject<CResultModifier>::CreateInstance(&pResultModifier);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultModifier->m_strID = pTemp->strID;
		pResultModifier->m_strKeyword = pTemp->strKeyword;
		pResultModifier->m_strKName = pTemp->strKName;
		pResultModifier->m_strName = pTemp->strName;
		pResultModifier->m_strSynonymKbn = pTemp->strSynonymKbn;
		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultModifier->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
	 }

	oResultModifierList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetModifierNode(BSTR strModifierPath, BSTR strModifierID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetModifierNode ĂяoB
	CTypedPtrList <CPtrList, StructResultModifierNode * > oResultModifierNodeList;
	int nRet=gMedicalSearch.GetModifierNode(strModifierPath,
										strModifierID,&oResultModifierNodeList);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultModifierNodeList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultModifierNodeList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultModifierNode *pTemp = oResultModifierNodeList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultModifierNode>* pResultModifierNode;
		HRESULT hRes = CComObject<CResultModifierNode>::CreateInstance(&pResultModifierNode);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultModifierNode->m_bLost = pTemp->bLost;
		pResultModifierNode->m_strID = pTemp->strID;
		pResultModifierNode->m_strKName = pTemp->strKName;
		pResultModifierNode->m_strName = pTemp->strName;
		pResultModifierNode->m_strPath = pTemp->strPath;
		free((void*)pTemp->strPath);
		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultModifierNode->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	 }

	oResultModifierNodeList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetModifierJumpItem(BSTR strDiseaseID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetModifierJumpItem ĂяoB
	StructResultJumpItem oTempResultJumpItem;
	int nRet=gMedicalSearch.GetModifierJumpItem(strDiseaseID,oTempResultJumpItem);
	if(nRet != RETOK){
		return S_FALSE;
	}

	//CX^X
	CComObject<CResultModifierJumpItem>* pResultModifierJumpItem;
	HRESULT hRes = CComObject<CResultModifierJumpItem>::CreateInstance(&pResultModifierJumpItem);
	ATLASSERT(SUCCEEDED(hRes));

	//\̂̃f[^VARIANT^̕ϐփZbg
	pResultModifierJumpItem->m_strJumpInfo = oTempResultJumpItem.strJumpInfo;
	pResultModifierJumpItem->m_strKbnCode = oTempResultJumpItem.strKbnCode;
	pResultModifierJumpItem->m_strName = oTempResultJumpItem.strName;

	free((void*)oTempResultJumpItem.strJumpInfo);
	//\̂Av֓B
	IDispatch* pDisp=NULL;
	pResultModifierJumpItem->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetDiseaseDetail(BSTR strID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetDiseaseDetail ĂяoB
	DISEASEDETAIL oDiseaseDetail;
	int nRet=gMedicalSearch.GetDiseaseDetail(strID,oDiseaseDetail);
	if(nRet != RETOK){
		return S_FALSE;
	}

	//CX^X
	CComObject<CDiseaseDetail>* pDiseaseDetail = NULL;
	HRESULT hRes = CComObject<CDiseaseDetail>::CreateInstance(&pDiseaseDetail);
	ATLASSERT(SUCCEEDED(hRes));

	//\̂̃f[^VARIANT^̕ϐփZbg
	pDiseaseDetail->m_szModifierJumpInfo = oDiseaseDetail.szModifierJumpInfo;
	pDiseaseDetail->m_szCode = oDiseaseDetail.szNorCode;
	pDiseaseDetail->m_szConnectModifierKbnCode = oDiseaseDetail.szConnectModifierKbnCode;
	pDiseaseDetail->m_szResembleDiseaseCode = oDiseaseDetail.szResembleDiseaseCode;
	pDiseaseDetail->m_szResePrecision = oDiseaseDetail.szResePrecision;
	pDiseaseDetail->m_szReseName = oDiseaseDetail.szReseName;
	pDiseaseDetail->m_szReseCode = oDiseaseDetail.szReseCode;
	pDiseaseDetail->m_szICDCandidate = oDiseaseDetail.szICDCandidate;
	pDiseaseDetail->m_szICD10Precision = oDiseaseDetail.szICD10Precision;
	pDiseaseDetail->m_szICD10_2 = oDiseaseDetail.szICD10_2;
	pDiseaseDetail->m_szICD10_1 = oDiseaseDetail.szICD10_1;
	pDiseaseDetail->m_szExchangeCode = oDiseaseDetail.szExchangeCode;
	pDiseaseDetail->m_szSelectKbn = oDiseaseDetail.szSelectKbn;
	pDiseaseDetail->m_szKName = oDiseaseDetail.szKName;
	pDiseaseDetail->m_szName = oDiseaseDetail.szName;
	pDiseaseDetail->m_szID = oDiseaseDetail.szID;


	//\̂Av֓B
	IDispatch* pDisp=NULL;
	pDiseaseDetail->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetModifierDetail(BSTR strID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetModifierDetail ĂяoB
	MODIFIERDETAIL oModifierDetail;
	memset((void*)&oModifierDetail,0X00,sizeof(MODIFIERDETAIL));
	int nRet=gMedicalSearch.GetModifierDetail(strID,oModifierDetail);
	if(nRet != RETOK){
		return S_FALSE;
	}

	//CX^X
	CComObject<CModifierDetail>* pModifierDetail;
	HRESULT hRes = CComObject<CModifierDetail>::CreateInstance(&pModifierDetail);
	ATLASSERT(SUCCEEDED(hRes));

	//\̂̃f[^VARIANT^̕ϐփZbg
	pModifierDetail->m_szModifierComment = oModifierDetail.szModifierComment;
	pModifierDetail->m_szMasanCode = oModifierDetail.szMasanCode;
	pModifierDetail->m_szReseCode = oModifierDetail.szReseCode;
	pModifierDetail->m_szExcluSionCode = oModifierDetail.szExcluSionCode;
	pModifierDetail->m_szModifierKbn = oModifierDetail.szModifierKbn;
	pModifierDetail->m_szConnectPosKbn = oModifierDetail.szConnectPosKbn;
	pModifierDetail->m_szCode = oModifierDetail.szCode;
	pModifierDetail->m_szKName = oModifierDetail.szKName;
	pModifierDetail->m_szName = oModifierDetail.szName;
	pModifierDetail->m_szID = oModifierDetail.szID;

	//\̂Av֓B
	IDispatch* pDisp=NULL;
	pModifierDetail->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetKeywordDetail(BSTR strKeyWord, BSTR strID, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//
	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetKeywordDetail ĂяoB
	KEYWORDDETAIL oKeywordDetail;
	int nRet=gMedicalSearch.GetKeywordDetail(strKeyWord,strID,oKeywordDetail);
	if(nRet != RETOK){
		return S_FALSE;
	}

	//CX^X
	CComObject<CKeywordDetail>* pKeywordDetail;
	HRESULT hRes = CComObject<CKeywordDetail>::CreateInstance(&pKeywordDetail);
	ATLASSERT(SUCCEEDED(hRes));

	//\̂̃f[^VARIANT^̕ϐփZbg
	pKeywordDetail->m_szAbbrKbn = oKeywordDetail.szAbbrKbn;
	pKeywordDetail->m_szLangKbn = oKeywordDetail.szLangKbn;
	pKeywordDetail->m_sz1stUsed = oKeywordDetail.sz1stUsed;
	pKeywordDetail->m_szVariantKbn = oKeywordDetail.szVariantKbn;
	pKeywordDetail->m_szSynonymKbn = oKeywordDetail.szSynonymKbn;
	pKeywordDetail->m_szKNKbn = oKeywordDetail.szKNKbn;
	pKeywordDetail->m_szDMKbn = oKeywordDetail.szDMKbn;
	pKeywordDetail->m_szID = oKeywordDetail.szID;
	VariantInit(retval);

	//\̂Av֓B
	IDispatch* pDisp=NULL;
	pKeywordDetail->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetLatestErrorCode(long *nErrCode)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	long nTemp=-1;
	//NX̃\bh GetLatestErrorCode ĂяoB
	gMedicalSearch.GetLatestErrorCode(nTemp);
	*nErrCode=nTemp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetNormallzatlonDiseaseCode(BSTR szDiseaseID, VARIANT ArrInModifierID, 
							int nModifierNum, BSTR *szDiseaseNameExchangeCode, 
							BSTR *szOutDiseaseId, VARIANT *pOutArrModiferCode, 
							int *nOutModifierNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	//ArrInmodifierID̃f[^z֓n
	CStringArray oInArray;
	int nRet=VariantToStrArr(nModifierNum,&ArrInModifierID,oInArray);
	if(nRet != 0)
		return S_FALSE;

	CStringArray oOutArray;
	CString strDisExchggCode = _T("");
	CString strOutDisID = _T("");	
	
	nRet=gMedicalSearch.GetNormalizationDiseaseCode(szDiseaseID,oInArray,
					nModifierNum,strDisExchggCode,
					strOutDisID,oOutArray,*nOutModifierNum);
	if(nRet != RETOK)
		return S_FALSE;
	nRet=StrArrToVariant(oOutArray,pOutArrModiferCode);
	if(nRet != RETOK)
		return S_FALSE;
//chg by hzj begin
//	*szDiseaseNameExchangeCode = (BSTR)malloc(strDisExchggCode.GetLength() + 1);
//	*szOutDiseaseId = (BSTR)malloc(strOutDisID.GetLength() + 1);
	*szDiseaseNameExchangeCode=strDisExchggCode.AllocSysString();
	*szOutDiseaseId=strOutDisID.AllocSysString();
//chg by hzj end

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
CheckExclusive(BSTR szModifierID, VARIANT oArrInModiferID,int nInModCnt,
			   VARIANT_BOOL *bOutCheckResult)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	CStringArray oInArray;
	int nRet=VariantToStrArr(nInModCnt,&oArrInModiferID,oInArray);
	if(nRet != RETOK)
		return S_FALSE;

	BOOL bOutTemp=FALSE;
	nRet=gMedicalSearch.CheckExclusive(szModifierID,
		oInArray,bOutTemp);
	if(nRet != RETOK)
		return S_FALSE;
	else
		*bOutCheckResult=bOutTemp;
	return S_OK;
}

STDMETHODIMP BasicDBAccess::AddDiseasePath(BSTR szDiseaseID, BSTR *lpszDiseasePath)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	int nRet = gMedicalSearch.AddDiseasePath(szDiseaseID,lpszDiseasePath);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
ConvertDoubleSingleWord(int nKanaChangeType, int nAlphabetChangeType, 
						BSTR szPreChgWords, BSTR *lpszSufChgWords)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	int nRet = gMedicalSearch.ConvertDoubleSingleWord(nKanaChangeType,
							nAlphabetChangeType,szPreChgWords,lpszSufChgWords);
	if (nRet != RETOK) {
		return S_FALSE;
	}


	return S_OK;
}

STDMETHODIMP BasicDBAccess::ConvertHyphen(BSTR szPreChgWords, BSTR *lpszSufChgWords)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.ConvertHyphen(szPreChgWords,lpszSufChgWords);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
ConvertUpperLower(int nChangeType, BSTR szPreChgWords, BSTR *lpszSufChgWords)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.ConvertUpperLower(nChangeType,szPreChgWords,
													lpszSufChgWords);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
ConvertWord(BSTR szPreChgWords, BSTR *lpszSufChgWords)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.ConvertWord(szPreChgWords,lpszSufChgWords);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::DecomposeDiseasePath(BSTR *lpszDiseasePath, BSTR *lpszDisease)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())


	int nRet = gMedicalSearch.DecomposeDiseasePath(lpszDiseasePath,lpszDisease);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
EqualsSynonym(BSTR szPreCmpDiseaseName, BSTR szSufCmpDiseaseName, 
								VARIANT_BOOL *bCmpResult)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	BOOL bOutTemp=FALSE;
	int nRet = gMedicalSearch.EqualsSynonym(szPreCmpDiseaseName,
							szSufCmpDiseaseName,&bOutTemp);
	if (nRet != RETOK) {
		return S_FALSE;
	}
	else
		*bCmpResult=bOutTemp;

	return S_OK;
}


STDMETHODIMP BasicDBAccess::
GetFileVersion(BSTR szFilePath, BSTR *lpszFileVersion)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.GetFileVersion(szFilePath,lpszFileVersion);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}
STDMETHODIMP BasicDBAccess::
SortModifierCode(int nCount, VARIANT arrInModifierPos,
				 VARIANT arrInModifierCode, VARIANT *pOutModifierSortCode)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet=gMedicalSearch.SortModifierCode(nCount,arrInModifierPos,
									arrInModifierCode,pOutModifierSortCode);
	if(nRet != RETOK)
		return S_FALSE;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
DevelopWord(BSTR szPreDevelopWords, VARIANT *pArrSufDevelopWord, int *nDevelopNums)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.DevelopWord(szPreDevelopWords,
								pArrSufDevelopWord,nDevelopNums);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetBasicModifierCode(BSTR szInModifier, BSTR *lpszOutModifierCode)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.GetBasicModifierCode(szInModifier,
												lpszOutModifierCode);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::
GetBasicModifierID(BSTR szInModifier, BSTR *lpszOutModifierID)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.GetBasicModifierID(szInModifier,
											lpszOutModifierID);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::GetModPath(BSTR szId, BSTR *szPath)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	
	CString strPath = _T("");
	int nRet = gMedicalSearch.GetModifierPath(szId,strPath);
	if (nRet != RETOK) {
		return S_FALSE;
	}
//	trPath = _T("\\") + strPath;
	*szPath=strPath.AllocSysString();
	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchExchangeCodeKeyword(BSTR szExchangeCode, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetDiseaseNode ĂяoB
	CTypedPtrList <CPtrList, StructResultKeyword * > oResultKeywordList;
	int nRet=gMedicalSearch.SearchExchangeCodeKeyword(szExchangeCode,&oResultKeywordList);
	if(nRet != RETOK){
		return S_OK;
	}

	int nCount = oResultKeywordList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultKeywordList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultKeyword *pTemp = oResultKeywordList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultKeyword>* pResultKeyword;
		HRESULT hRes = CComObject<CResultKeyword>::CreateInstance(&pResultKeyword);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
		pResultKeyword->m_strKeyword = CString(pTemp->strKeyword);
		pResultKeyword->m_strEquCode = CString(pTemp->strEquCode);
		pResultKeyword->m_strSynonymKbn = CString(pTemp->strSynonymKbn);

		delete pTemp;
		pTemp = NULL;

		LPDISPATCH lpDisp = NULL;
		pResultKeyword->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	}

	oResultKeywordList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchModifierCodeKeyword(BSTR szModifierCode, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh GetDiseaseNode ĂяoB
	CTypedPtrList <CPtrList, StructResultKeyword * > oResultKeywordList;
	int nRet=gMedicalSearch.SearchModifierCodeKeyword(szModifierCode,&oResultKeywordList);
	if(nRet != RETOK){
		return S_OK;
	}

	int nCount = oResultKeywordList.GetCount();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

	POSITION pos = oResultKeywordList.GetHeadPosition();
	int i = 0;
	while(pos)
	{
		StructResultKeyword *pTemp = oResultKeywordList.GetNext(pos);
		ATLASSERT(pTemp);

     	//CX^X
		CComObject<CResultKeyword>* pResultKeyword;
		HRESULT hRes = CComObject<CResultKeyword>::CreateInstance(&pResultKeyword);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultKeyword->m_strKeyword = CString(pTemp->strKeyword);

		delete pTemp;
		pTemp = NULL;

		LPDISPATCH lpDisp = NULL;
		pResultKeyword->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
		i++;
	}

	oResultKeywordList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}

STDMETHODIMP BasicDBAccess::ConvertHiraKata(int nChangeType, BSTR szPreWords, BSTR *lpszSufWords)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	CString strData = _T("");
	CString strResults = _T("");

	strData = SysAllocString(szPreWords);
	int nRet = gMedicalSearch.ConvertHiraKata(nChangeType,szPreWords,strResults);

	if (nRet != RETOK) {
		return S_FALSE;
	}

	*lpszSufWords = strResults.AllocSysString();

	return S_OK;
}

STDMETHODIMP BasicDBAccess::InitializeCodingInfo(BSTR FileName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	//NX̃\bh Initialize ĂяoB
	int nRet=gMedicalSearch.InitializeCoding(FileName);
	if(nRet != RETOK)
		return S_FALSE;
	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchCodingInfo(BSTR szICD10, BSTR *lpszMsg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	int nRet = gMedicalSearch.GetCsvMsg(szICD10,lpszMsg);
	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchCompatibleDisease(BSTR szExchangeCode, BSTR *lpszDiseaseID)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	int nRet = gMedicalSearch.GetDiseaseID(szExchangeCode,lpszDiseaseID);

	if (nRet != RETOK) {
		return S_FALSE;
	}

	return S_OK;
}

STDMETHODIMP BasicDBAccess::SearchDiseaseKeywordAnd(int nRetrieveSegerRange, BSTR szDiseasePath, BSTR szKeyword, BSTR szSynonymKbn, int nMostRetrieveNum, VARIANT_BOOL *bOutReward, VARIANT_BOOL *bOutNumOver, VARIANT *retval)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	VariantInit(retval);
	retval->vt = VT_DISPATCH;
	retval->pdispVal = NULL;

	//NX̃\bh SearchDiseaseKeywordAnd ĂяoB
	CTypedPtrArray <CPtrArray, StructResultDisease * > oResultDiseaseList;
	int nRet=gMedicalSearch.SearchDiseaseKeywordAnd(nRetrieveSegerRange,
						szDiseasePath,szKeyword,szSynonymKbn,
						nMostRetrieveNum,&oResultDiseaseList,
						(BOOL*)bOutReward,(BOOL*)bOutNumOver);
	if(nRet != RETOK){
		return S_FALSE;
	}
	int nCount = oResultDiseaseList.GetSize();
	if(nCount<=0){
		return S_FALSE;
	}

	CComObject<CResultNodeList>* pResultNodeList = new CComObject<CResultNodeList>;
	//IXg
	pResultNodeList->m_pVector = new CComVariant[nCount];
	pResultNodeList->m_nCount = nCount;

//	POSITION pos = oResultDiseaseList.GetHeadPosition();
//	int i = 0;
	for(int i=0;i<nCount;i++)
	{
		StructResultDisease *pTemp = oResultDiseaseList.GetAt(i);
		ASSERT(pTemp);

     	//CX^X
		CComObject<CResultDisease>* pResultDisease;
		HRESULT hRes = CComObject<CResultDisease>::CreateInstance(&pResultDisease);
		ATLASSERT(SUCCEEDED(hRes));

		//\̃Xg̃f[^VARIANT^̕ϐփZbg
        pResultDisease->m_strID = pTemp->strID;
		pResultDisease->m_strKeyword = pTemp->strKeyword;
		pResultDisease->m_strKName = pTemp->strKName;
		pResultDisease->m_strName = pTemp->strName;
		pResultDisease->m_strPath = pTemp->strPath;
		pResultDisease->m_strSelectKbn = pTemp->strSelectKbn;
		pResultDisease->m_strSynonymKbn = pTemp->strSynonymKbn;
		free((void*)pTemp->strPath);
		delete pTemp;

		LPDISPATCH lpDisp = NULL;
		pResultDisease->QueryInterface(IID_IDispatch, (void**)&lpDisp);
		ATLASSERT(lpDisp);

		//\̂̔z̗vfZbg
		CComVariant& var = pResultNodeList->m_pVector[i];
		var.vt = VT_DISPATCH;
		var.pdispVal = lpDisp;
	 }

	oResultDiseaseList.RemoveAll();

	//\̃XgAv֓B
	IDispatch* pDisp = NULL;
	pResultNodeList->QueryInterface(IID_IDispatch,(void**)&pDisp);
	ATLASSERT(pDisp);
	retval->pdispVal = pDisp;

	return S_OK;
}
